package applications.links;

import terms.*;
import algebras.*;
import parsers.*;
import java.util.Hashtable;

public class linkAlgebra extends algebra {

  private Hashtable<String,link> constants = new Hashtable<String,link>();

  protected Object apply(symbol op, Object[] args) {
    if (op.rank() == 0) {
      if (constants.containsKey(op.toString())) return (link)constants.get(op.toString()).clone();
      else if (isPush(op)) return link.push();
      else if (isPop(op)) return link.pop();
      else return link.emptyLink();      
    }
    else {
      link result = (link)args[0];
      for (int i = 1; i < args.length; i++) result.concatWith((link)args[i]);
      return result;
    }
  }
  
  private boolean isPush(symbol op) {
    if (op.rank() != 0) return false;
    return op.toString() == "[" || op.toString().equals("push");
  }
  
  private boolean isPop(symbol op) {
    if (op.rank() != 0) return false;
    return op.toString() == "]" || op.toString().equals("pop");
  }
  
  public boolean addConstant(String name, link l) {
    if (constants.containsKey(name)) return false;
    constants.put(name,l);
    return true;
  }

  /** Initialize a <code>linkAlgebra</code> by reading its definition from a stream.
    * @see linkAlgebraParser
    * @exception ParseException if an error occurs
    */
    public void parse(ASCII_CharStream stream) throws ParseException {
      linkAlgebraParser parser = new linkAlgebraParser(stream);
      parser.linkAlgebra(this);
    }

}
