package gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.SwingUtilities;

import util.*;

public class popupMenu extends PopupMenu {
  
  /**
	 * 
	 */
  private static final long serialVersionUID = -4034240825852152760L;

  public popupMenu(ActionListener notify) {
    super();
    addActionListener(notify);
  }
  
  public void setCommands(list commands) {
    if (SwingUtilities.isEventDispatchThread()) doSetCommands(commands);
    else SwingUtilities.invokeLater(new updater(commands));
  }
  
  public void doSetCommands(list commands) {
    removeAll();
    while (!commands.isEmpty()) {
      String[] command = (String[])commands.head();
      for (int i = 0; i < command.length; i++) add(new MenuItem(command[i]));
      commands = commands.tail();
      if (!commands.isEmpty()) addSeparator();
    }
  }
  
  private class updater implements Runnable {
    
    list com;
    
    public updater (list com) {
      this.com = com;
    }
    
    public void run() {
      doSetCommands(com);
    }
  }
  
}
  
