/* Generated By:JavaCC: Do not edit this line. objectParser.java */
package parsers;

import util.*;

public class objectParser implements objectParserConstants {

  private nameParser names;

  private ASCII_CharStream inputStream = null;

  public objectParser(ASCII_CharStream input) {
    this(new objectParserTokenManager(input));
    inputStream = input;
  }

/** Parse an object definition.
  * The syntax is <code>&lt;classname&gt;: &lt;definition&gt;</code>.
  * Here, <code>&lt;classname&gt;</code> is the name of a class that
  * implements the interface <code>parsable</code>, and
  * <code>&lt;definition&gt;</code> follows the ``local'' syntax of
  * <code>&lt;classname&gt;</code>.
  * @exception ParseException if an error occurs
  */
  final public parsable parse() throws ParseException {
  String className;
  String identString=null;
  int len;
  names = new nameParser(inputStream);
     className = names.name();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      break;
    case LEFT_PAR:
      jj_consume_token(LEFT_PAR);
       identString = names.name();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(COLON);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    parsable result = null;
    try {
      Class cl = Class.forName(className);
      Object inst = cl.newInstance();
      if (inst instanceof parsable) {
        result = (parsable)inst;
        result.parse(inputStream);
      }
      else {if (true) throw new ParseException("Class " + className +
                                                 " not a subclass of the class `parsable'");}
    } catch (ClassNotFoundException e) {
      {if (true) throw new ParseException("Class not found: " + className);}
    } catch (NoClassDefFoundError e) {
      {if (true) throw new ParseException("Class not found: " + className);}
    } catch (IllegalAccessException e) {
      {if (true) throw new ParseException("Could not build an instance of class " + className);}
    } catch (InstantiationException e) {
      {if (true) throw new ParseException("Cannot instantiate: " + className);}
    }
    if (identString != null) result.setName(identString);
    result.setClassName(className.substring(className.lastIndexOf(".")+1));
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  public objectParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[1];
  final private int[] jj_la1_0 = {0x140,};

  public objectParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new objectParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public objectParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new objectParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public objectParser(objectParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  public void ReInit(objectParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 1; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[9];
    for (int i = 0; i < 9; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 1; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 9; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
